-- Blossom

local BLOSSOM_CHANCE = 10 -- / 1000
local BLOSSOM_DELAY = 7200

minetest.register_node("nature:blossom", {
    description = "Blossom",
    drawtype = "allfaces_optional",
    tile_images = { "nature_blossom.png" },
    paramtype = "light",
    groups = { snappy = 3 },
})

minetest.register_craft({
    type = "fuel",
    recipe = "nature:blossom",
    burntime = 1,
})

-- Blossoming
minetest.register_abm({
    nodenames = { "default:leaves" },
    interval = BLOSSOM_DELAY,
    chance = 3,

    action = function(pos, node, active_object_count, active_object_count_wider)
        if(math.random(1, 1000) > BLOSSOM_CHANCE) then
            return
        end
        minetest.env:remove_node(pos)
        minetest.env:add_node(pos, { name = "nature:blossom" })
    end
})

-- Apples growing
minetest.register_abm({
    nodenames = { "nature:blossom" },
    interval = BLOSSOM_DELAY,
    chance = 3,

    action = function(pos, node, active_object_count, active_object_count_wider)
        if(math.random(1, 1000) > BLOSSOM_CHANCE) then
            return
        end
        minetest.env:remove_node(pos)
        minetest.env:add_node(pos, { name = "default:apple" })
    end
})

-- Apples decaying
minetest.register_abm({
    nodenames = { "default:apple" },
    interval = BLOSSOM_DELAY,
    chance = 3,

    action = function(pos, node, active_object_count, active_object_count_wider)
        if(math.random(1, 1000) > BLOSSOM_CHANCE) then
            return
        end
        minetest.env:remove_node(pos)
        minetest.env:add_node(pos, { name = "default:leaves" })
    end
})
